﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

public partial class Admin_NewEntry : System.Web.UI.Page
{
    protected override void OnInit(EventArgs e)
    {
        HtmlGenericControl body = this.Master.FindControl("AdminMasterBody") as HtmlGenericControl;
        body.Attributes.Add("onunload", "GUnload();");
        body.Attributes.Add("onload", "load()");

        base.OnInit(e);
    }
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void EntryDateCalendar_SelectionChanged(object sender, EventArgs e)
    {
        EntryDateTextBox.Text = EntryDateCalendar.SelectedDate.ToString("yyyy/MM/dd");
    }

    protected string GetContentsTextBoxUniqueID()
    {
        return this.ContentsTextBox.ClientID;
    }

    protected string GetHiddenLocation_Lng_ID()
    {
        return this.hidden_location_Lng.ClientID;
    }

    protected string GetHiddenLocation_Lat_ID()
    {
        return this.hidden_location_Lat.ClientID;
    }

    protected string GetHiddenZoom_ID()
    {
        return this.hidden_Zoom.ClientID;
    }

    protected string GetHidden_marker_Lng_ID()
    {
        return this.hidden_marker_Lng.ClientID;
    }

    protected string GetHidden_marker_Lat_ID()
    {
        return this.hidden_marker_Lat.ClientID;
    }

    protected string GetEnableLocationInfo_ID()
    {
        return this.hidden_enableLocationInfo.ClientID;
    }

    protected void EntryButton_Click(object sender, EventArgs e)
    {
        if (this.IsValid)
        {
            if ("1" == this.hidden_enableLocationInfo.Value)
            {
                EntryWithLocationDataSource.Insert();
            }
            else
            {
                EntryDataSource.Insert();
            }
        }

        Response.Redirect("NewEntry.aspx", false);
    }
    protected void EntryDataSource_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        int newIdentity = (int)e.ReturnValue;
        FileUpload[] fileUploads = { ImageFileUpload1, ImageFileUpload2, ImageFileUpload3 };
        EntryBL entryBL = new EntryBL();
        entryBL.SaveImageFiles(newIdentity, fileUploads);
    }

    /// <summary>
    /// Handler for calendar changes
    /// </summary>
    /// <param name="sender">source</param>
    /// <param name="e">arguments</param>
    protected void Calendar1_SelectionChanged(object sender, EventArgs e)
    {
        // Popup result is the selected date
        PopupControlExtender1.Commit(EntryDateCalendar.SelectedDate.ToShortDateString());
    }

}
