﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Text;

public partial class _Default : System.Web.UI.Page
{
    const string EntryID = "EntryID";
    const string CategoryID = "CategoryID";
    const string CommentID = "CommentID";
    const string Archive = "Archive";

    protected int? entryIDParam = null;
    protected int? categoryIDParam = null;
    protected int? commentIDParam = null;
    protected DateTime? archiveParam = null;

    protected override void OnInit(EventArgs e)
    {
        HtmlGenericControl body = this.Master.FindControl("MasterBody") as HtmlGenericControl;
        body.Attributes.Add("onunload", "GUnload();");

        ParseRequestParameters();
        if (null != this.entryIDParam)
        {
            this.EntryRepeater.DataSourceID = "EntryObjectDataSource";
            //this.PopupBehaviorRepeater.DataSourceID = "EntryObjectDataSource";
        }
        else if (null != this.categoryIDParam)
        {
            this.EntryRepeater.DataSourceID = "CategoryEntryObjectDataSource";
            //this.PopupBehaviorRepeater.DataSourceID = "CategoryEntryObjectDataSource";
        }
        else if (null != this.archiveParam)
        {
            this.EntryRepeater.DataSourceID = "DateEntryObjectDataSource";
            //this.PopupBehaviorRepeater.DataSourceID = "DateEntryObjectDataSource";
        }
        else
        {
            this.EntryRepeater.DataSourceID = "RecentEntryObjectDataSource";
            //this.PopupBehaviorRepeater.DataSourceID = "RecentEntryObjectDataSource";
        }

        base.OnInit(e);
    }
    
    protected void ParseRequestParameters()
    {
        if (null != Request.QueryString[EntryID])
        {
            try
            {
                this.entryIDParam = int.Parse(Request.QueryString[EntryID]);
            }
            catch
            {
            }
        }

        if (null != Request.QueryString[CategoryID])
        {
            try
            {
                this.categoryIDParam = int.Parse(Request.QueryString[CategoryID]);
            }
            catch
            {
            }
        }

        if (null != Request.QueryString[Archive])
        {
            try
            {
                string s = Request.QueryString[Archive];
                if (6 == s.Length)
                {
                    this.archiveParam = new DateTime(int.Parse(s.Substring(0, 4)), int.Parse(s.Substring(4, 2)), 1);
                }
            }
            catch
            {
            }
        }
        if (null != Request.QueryString[CommentID])
        {
            try
            {
                this.commentIDParam = int.Parse( Request.QueryString[CommentID] );
            }
            catch
            {
            }
        }
    }

    protected void CommentButton_Click(object sender, EventArgs e)
    {
        LinkButton button = sender as LinkButton;
        foreach (RepeaterItem repeaterItem in EntryRepeater.Items)
        {
            LinkButton currentItemButton = repeaterItem.FindControl(button.ID) as LinkButton;
            if( null != currentItemButton)
            {
                if (button.CommandArgument == currentItemButton.CommandArgument)
                {
                    foreach (Control control in repeaterItem.Controls)
                    {
                        //if (control is Microsoft.Web.UI.UpdatePanel)
                        if (control is System.Web.UI.UpdatePanel)
                        {
                            //Microsoft.Web.UI.UpdatePanel updatePanel = control as Microsoft.Web.UI.UpdatePanel;
                            System.Web.UI.UpdatePanel updatePanel = control as System.Web.UI.UpdatePanel;
                            //updatePanel.Visible = !updatePanel.Visible;
                            foreach (Control c in updatePanel.Controls[0].Controls)
                            {
                                if (c is Panel)
                                {
                                    c.Visible = !c.Visible;
                                }
                            }
                            
                        }
                    }
                }
            }
        }
    }

    protected string GetLocationDisplayString(object item)
    {
        DataRowView view = item as DataRowView;
        if( (bool)view["LocationInfo"] )
            return "block";
        return "none";
    }

    protected string CreateLocationButonClickHandler(int index, object item)
    {
        string result = "";

        DataRowView view = item as DataRowView;
        if ((bool)view["LocationInfo"])
        {
            result = "ShowGoogleMap(" +
                index.ToString() + ", " +
                view["Location_Lng"].ToString() + ", " +
                view["Location_Lat"].ToString() + ", " +
                view["Zoom"].ToString() + ", " +
                view["Marker_Lng"].ToString() + ", " +
                view["Marker_Lat"].ToString() + "); return false;";
        }
        return result;
    }

    protected string GetSmallImageUrl(int index, object item)
    {
        string result = "";
        DataRowView view = item as DataRowView;
        int id = (int)view["ID"];
        string fileName = view["Image" + index.ToString() + "FileName"] as string;
        if (null != fileName)
        {
            result = "./Image/" + id.ToString() + "/" + Path.GetFileNameWithoutExtension(fileName) + "_small" + Path.GetExtension(fileName);
        }
        return result;
    }

    protected string GetImageUrl(int index, object item)
    {
        string result = "";
        DataRowView view = item as DataRowView;
        int id = (int)view["ID"];
        string fileName = view["Image" + index.ToString() + "FileName"] as string;
        if (null != fileName)
        {
            result = "./Image/" + id.ToString() + "/" + Path.GetFileNameWithoutExtension(fileName) + Path.GetExtension(fileName);
        }
        return result;
    }
}
