﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public class SimpleCustomControl : Control {
  // Control Stateに保存する値（プロパティ）
  int _currentIndex = 0;

  protected override void OnInit(EventArgs e) {
    // ページに対して自分（SimpleCustomControl）がControl Stateを必要とすることを宣言します
    Page.RegisterRequiresControlState(this);
    base.OnInit(e);
  }
  
  // Control Stateのセーブメソッドをオーバーライド
  protected override object SaveControlState() {
    object[] states = new object[2];
    states[0] = base.SaveControlState();
    states[1] = _currentIndex;
    return states;
  }

  // Control Stateのロードメソッドをオーバーライド
  protected override void LoadControlState( object savedState) {
    object[] states = (object[])savedState;
    base.LoadControlState( states[0] );
    _currentIndex = (int)states[1];
  }
}
